SystemOrganization addCategory: #TusLibros!

TestCase subclass: #TusLibrosTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!TusLibrosTest methodsFor: 'Cart Instances' stamp: 'JuanManuelTastzian 5/29/2013 18:23'!
emptyCart
	^Cart newEmptyCart! !

!TusLibrosTest methodsFor: '1 - Cart Test' stamp: 'JuanManuelTastzian 5/29/2013 18:34'!
test1CartShouldBeEmptyAfterCreation
	self assert: self emptyCart size = 0! !

!TusLibrosTest methodsFor: '1 - Cart Test' stamp: 'JuanManuelTastzian 5/29/2013 18:47'!
test2CartSizeShouldBeGreaterThan0AfterAddingABookToIt
	| cart book |
	cart := Cart newEmptyCart.
	book := Book new.
	cart add: book.
	self assert: cart size > 0.! !

!TusLibrosTest methodsFor: '1 - Cart Test' stamp: 'JuanManuelTastzian 5/29/2013 19:16'!
test3aBookShouldBeListedAfterBeingAddedToACart
	| cart book |
	cart := Cart newEmptyCart.
	book := Book new.
	cart add: book.
	self assert: (cart includes: book)! !

!TusLibrosTest methodsFor: '1 - Cart Test' stamp: 'JuanManuelTastzian 5/29/2013 19:20'!
test4aCartHasOnlyOneBookAfterAddingABookToAnEmptyCart
	| cart book |
	cart := Cart newEmptyCart.
	book := Book new.
	cart add: book.
	self assert: (cart includes: book).
	self assert: cart size = 1! !

!TusLibrosTest methodsFor: '1 - Cart Test' stamp: 'JuanManuelTastzian 5/29/2013 19:28'!
test5aBookCanBeAddedMoreThanOnce
	| cart book anotherBook |
	
	cart := Cart newEmptyCart.
	book := Book new.
	anotherBook := Book new.
	
	cart add: book.
	cart add: book.
	cart add: anotherBook.
	
	self assert: (cart includes: book).
	self assert: cart size = 3.
	self assert: (cart numberOfUnitsAddedOf: book) = 2.
	self assert: (cart numberOfUnitsAddedOf: anotherBook) = 1.! !

Object subclass: #Book
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

Object subclass: #Cart
	instanceVariableNames: 'size books'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

Cart class
	instanceVariableNames: 'size'!

Cart class
	instanceVariableNames: 'size'!

!Cart class methodsFor: 'class initialization' stamp: 'JuanManuelTastzian 5/29/2013 18:30'!
newEmptyCart
	^self new withoutBooks! !

!Cart methodsFor: 'accessing' stamp: 'JuanManuelTastzian 5/29/2013 19:30'!
add: aBook 
	(aBook isKindOf: Book) ifTrue: [self books add: aBook]! !

!Cart methodsFor: 'accessing' stamp: 'JuanManuelTastzian 5/29/2013 18:36'!
books
	^ books! !

!Cart methodsFor: 'accessing' stamp: 'JuanManuelTastzian 5/29/2013 19:16'!
includes: aBook 
	^books includes: aBook! !

!Cart methodsFor: 'accessing' stamp: 'JuanManuelTastzian 5/29/2013 19:26'!
numberOfUnitsAddedOf: aBook 
	^(books occurrencesOf: aBook)! !

!Cart methodsFor: 'as yet unclassified' stamp: 'JuanManuelTastzian 5/29/2013 18:38'!
size
	^books size! !

!Cart methodsFor: 'accessing' stamp: 'JuanManuelTastzian 5/29/2013 18:38'!
withoutBooks
	books := Bag new.! !
